#include <windows.h>
const char g_szClassName[] = "shut_down_event";
void DllStuff(int action);
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch(msg)
    {
		case WM_CREATE:
		{
			DllStuff(1);
		}
			break;
        case WM_CLOSE:
		{
			DllStuff(2);
            DestroyWindow(hwnd);
		}
        break;
        case WM_DESTROY:
            PostQuitMessage(0);
        break;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASSEX wc;
    HWND hwnd;
    MSG Msg;
    wc.cbSize        = sizeof(WNDCLASSEX);
    wc.style         = 0;
    wc.lpfnWndProc   = WndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = g_szClassName;
    wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION);
    if(!RegisterClassEx(&wc))
    {
        MessageBox(NULL, "Window Registration Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }
    hwnd = CreateWindowEx(
        WS_EX_CLIENTEDGE,
        g_szClassName,
        "POC window",
        WS_OVERLAPPEDWINDOW,
        CW_USEDEFAULT, CW_USEDEFAULT, 240, 120,
        NULL, NULL, hInstance, NULL);
    if(hwnd == NULL)
    {
        MessageBox(NULL, "Window Creation Failed!", "Error!",
            MB_ICONEXCLAMATION | MB_OK);
        return 0;
    }

    ShowWindow(hwnd, SW_HIDE);
    UpdateWindow(hwnd);
    while(GetMessage(&Msg, NULL, 0, 0) > 0)
    {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
    }
    return Msg.wParam;
}
void DllStuff(int action)
{
	HINSTANCE hinst = LoadLibrary("shut_down_event.dll");
	if (hinst)
	{
	 typedef void (*Install)();
	 typedef void (*Uninstall)();
	 Install install = (Install) GetProcAddress(hinst, "install");
	 Uninstall uninstall = (Uninstall) GetProcAddress(hinst, "uninstall");
	if(action == 1)
	{
		install();
	    MSG msg;
		while(GetMessage(&msg, NULL, 0, 0) > 0)
		{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		}
	}
	if(action == 2)
	{
		uninstall();
	}
  }
	else
	{
		MessageBox(NULL,"Load library failed somehow :(","DEBUG",MB_OK);
	}
}

